package Absyn;

import NLObject.NLObject;
import Interp.Interp;
import java.util.LinkedList;
import Parse.Token;

public class Func extends Stmt implements NLObject
{
    public Token id;
    public LinkedList params;
    public Stmt body;

    public Func(Token id, LinkedList params, Stmt body)
    {
        this.id     = id;
        this.params = params;
        this.body   = body;
    }

    public String toString()
    {
        return "function:" + id.image;
    }

    public String getType()
    {
        return "function";
    }

    public NLObject op(String op, NLObject nlo)
    {
        String err = "Cannot apply '" + op + "' in '" + getType() +
                     " " + op + " " + nlo.getType() + "'.";
        Interp.error(err);
        return null;
    }
}
