package Absyn;

import Parse.Token;
import NLObject.*;
import Interp.Interp;

public class Literal extends Expr
{
    public NLObject nlo;

    public Literal(Token lit)
    {
        String s = lit.image;

        if(s.equals("true"))
            this.nlo = new Bool(true);

        else if(s.equals("false"))
            this.nlo = new Bool(false);

        else if(s.startsWith("\""))
            this.nlo = new Str(s.substring(1, s.length()-1));

        else if(s.startsWith("'"))
            this.nlo = new Pat(s);

        else // parse an integer
        {
            try
            {
                int i = Integer.parseInt(s);
                this.nlo = new Int(i);
            }
            catch(Exception e) // fail
            {
                Interp.error("Bad literal: '" + 
                             lit.image + "' on line: " +
                             lit.beginLine + ".");
                this.nlo = null;
            }
        }
    }
}
