package Interp;

import java.util.LinkedList;
import NLObject.*;

public class SymTab
{
    class Entry
    {
        String   id;
        NLObject val;

        Entry(String id, NLObject val)
        {
            this.id  = id;
            this.val = val;
        }
    }

    LinkedList tab;

    public SymTab()
    {
        tab = new LinkedList();
    }

    public void startScope()
    {
        tab.add(null);
    }

    public void endScope()
    {
        int i = tab.size()-1;

        for(; i>=0; i--)
        {
            Object o = tab.remove(i);
            if(o == null) break;
        }
    }

    public void bind(String id, NLObject val)
    {
        // only update the (id, val) for the local scope
        
        for(int i=tab.size()-1; i>=0; i--)
        {
            Object o = tab.get(i);
            if(o == null) break;
            Entry e = (Entry)o;

            // if id already exists in table
            if(id.equals(e.id))
            {
                // update val and get out
                e.val = val;
                return;
            }
        }

        // no match found add new entry
        Entry e = new Entry(id, val);
        tab.add(e);
    }

    public NLObject lookup(String id)
    {
        for(int i=tab.size()-1; i>=0; i--)
        {
            Object o = tab.get(i);
            if(o == null) continue;
            Entry e = (Entry)o;

            // if this is the id we want return it's val
            if(id.equals(e.id))
                return e.val;
        }

        Interp.error("ID '" + id + "' is not bound to any value.");
        return null;
    }
}
