import java.util.*;
import java.io.*;

import Parse.*;
import Absyn.*;
import Sculpture.*;
import Interp.*;
import NLObject.*;

public class Main
{
	public static void main(String args[]) throws Exception
	{
		if(args.length < 1)
		{
            System.err.println("Usage: java Main <input file> [ -cprog ]");
        }

        InputStream in = new FileInputStream(args[0]);
        SimpleCharStream ascii = new SimpleCharStream(in, 1, 0);
        NLTokenManager lexer = new NLTokenManager(ascii);

        LinkedList stmts = null;
        StringSculpt sculpt = new StringSculpt();
        Pat.SIZE = StringSculpt.SIZE;

        try
        {
            stmts = new NL(lexer).Program();
        }
        catch(ParseException e)
        {
            System.err.println(e);
            System.exit(1);
        }

        if(args.length == 2 && args[1].equals("-cprog"))
        {
            Interp.FOR_C_DRIVER = true;
            Pat.SIZE = 55;
        }

        Interp interp = new Interp(stmts, sculpt);
        System.out.println(interp.out);
    }
}
