package NLObject;

import Interp.Interp;
import java.util.LinkedList;

public class Bool implements NLObject
{
    public boolean bool;

    public Bool(boolean bool)
    {
        this.bool = bool;
    }

    public String getType()
    {
        return "boolean";
    }

    public String toString()
    {
        return "" + bool;
    }

    public NLObject op(String op, NLObject nlo)
    {
        if(op.equals("not") && nlo instanceof NLVoid)
            return new Bool(!bool);

        if(op.equals("or") && nlo instanceof Bool)
            return new Bool(bool || ((Bool)nlo).bool);

        if(op.equals("and") && nlo instanceof Bool)
            return new Bool(bool && ((Bool)nlo).bool);

        if(op.equals("in") && nlo instanceof List)
        {
            String target = toString();
            List hay = (List)nlo;

            for(int i=0; i<hay.list.size(); i++)
            {
                String cand = hay.list.get(i).toString();
                if(target.equals(cand))
                    return new Bool(true);
            }

            return new Bool(false);
        }

        if(op.equals("$") && nlo instanceof List)
        {
            LinkedList l = new LinkedList();
            l.addAll( ((List)nlo).list );
            l.addFirst(nlo);
            return new List(l);
        }

        if(op.equals("=="))
        {
            if(nlo instanceof Bool)
                return new Bool(bool == ((Bool)nlo).bool);

            Interp.warn("Comparing " + getType() + " and " + 
                        nlo.getType() + ".");
            return new Bool(false);
        }

        if(op.equals("!="))
        {
            if(nlo instanceof Bool)
                return new Bool(bool != ((Bool)nlo).bool);

            Interp.warn("Comparing " + getType() + " and " + 
                        nlo.getType() + ".");
            return new Bool(true);
        }

        Interp.error("Cannot apply '" + op + "' in '" + getType() + 
                     " " + op + " " + nlo.getType() + "'.");
        return null;
    }
}
