package NLObject;

import Interp.Interp;
import java.util.LinkedList;

public class Int implements NLObject
{
    public int i;

    public Int(int i)
    {
        this.i = i;
    }

    public String getType()
    {
        return "int";
    }

    public String toString()
    {
        return "" + i;
    }

    public NLObject op(String op, NLObject nlo)
    {
        if(op.equals("~") && nlo instanceof NLVoid)
            return new Int(~i);

        if(op.equals("*") && nlo instanceof Int)
            return new Int(i * ((Int)nlo).i);

        if(op.equals("/") && nlo instanceof Int)
            return new Int(i / ((Int)nlo).i);

        if(op.equals("%") && nlo instanceof Int)
            return new Int(i % ((Int)nlo).i);

        if(op.equals("+") && nlo instanceof Int)
            return new Int(i + ((Int)nlo).i);

        if(op.equals("-") && nlo instanceof Int)
            return new Int(i - ((Int)nlo).i);

        if(op.equals("<<") && nlo instanceof Int)
            return new Int(i << ((Int)nlo).i);

        if(op.equals(">>") && nlo instanceof Int)
            return new Int(i >> ((Int)nlo).i);

        if(op.equals("&") && nlo instanceof Int)
            return new Int(i & ((Int)nlo).i);

        if(op.equals("^") && nlo instanceof Int)
            return new Int(i ^ ((Int)nlo).i);

        if(op.equals("|") && nlo instanceof Int)
            return new Int(i | ((Int)nlo).i);

        if(op.equals("<") && nlo instanceof Int)
            return new Bool(i < ((Int)nlo).i);

        if(op.equals("<=") && nlo instanceof Int)
            return new Bool(i <= ((Int)nlo).i);

        if(op.equals(">") && nlo instanceof Int)
            return new Bool(i > ((Int)nlo).i);

        if(op.equals(">=") && nlo instanceof Int)
            return new Bool(i >= ((Int)nlo).i);

        if(op.equals("in") && nlo instanceof List)
        {
            String target = toString();
            List hay = (List)nlo;

            for(int i=0; i<hay.list.size(); i++)
            {
                String cand = hay.list.get(i).toString();
                if(target.equals(cand))
                    return new Bool(true);
            }

            return new Bool(false);
        }

        if(op.equals("$") && nlo instanceof List)
        {
            LinkedList l = new LinkedList();
            l.addAll( ((List)nlo).list );
            l.addFirst(nlo);
            return new List(l);
        }

        String warn = "Comparing "+ getType() +" and "+ nlo.getType() +".";

        if(op.equals("=="))
        {
            if(nlo instanceof Int)
                return new Bool(i == ((Int)nlo).i);

            Interp.warn(warn);
            return new Bool(false);
        }

        if(op.equals("!="))
        {
            if(nlo instanceof Int)
                return new Bool(i != ((Int)nlo).i);

            Interp.warn(warn);
            return new Bool(true);
        }

        String err = "Cannot apply '" + op + "' in '" + getType() +
                     " " + op + " " + nlo.getType() + "'.";
        Interp.error(err);
        return null;
    }
}
