package NLObject;

import Interp.Interp;
import java.util.LinkedList;

public class List implements NLObject
{
    public LinkedList list;

    public List(LinkedList nlos)
    {
        list = new LinkedList();
        list.addAll(nlos);
    }

    public String getType()
    {
        return "list";
    }

    public String toString()
    {
        String res = "[";

        boolean first = true;
        for(int i=0; i<list.size(); i++)
        {
            if(first)
            {
                res += list.get(i).toString();
                first = false;
            }
            else
            {
                res += ", " + list.get(i).toString();
            }
        }

        res += "]";

        return res;
    }

    public NLObject getElt(int i)
    {
        if(i < 0 || i >= list.size())
        {
            Interp.error("Invalid list index: " + i);
            return null; 
        }

        return (NLObject)list.get(i);
    }

    public NLObject op(String op, NLObject nlo)
    {
        if(op.equals("in") && nlo instanceof List)
        {
            String target = toString();
            List hay = (List)nlo;

            for(int i=0; i<hay.list.size(); i++)
            {
                String cand = hay.list.get(i).toString();
                if(target.equals(cand))
                    return new Bool(true);
            }

            return new Bool(false);
        }

        if(op.equals("$") && nlo instanceof List)
        {
            LinkedList l = new LinkedList();
            l.addAll( ((List)nlo).list );
            l.addFirst(nlo);
            return new List(l);
        }

        if(op.equals("@"))
        {
            LinkedList l = new LinkedList();
            l.addAll(list);
            l.add(nlo);
            return new List(l);
        }

        String warn = "Comparing "+ getType() +" and "+ nlo.getType() +".";

        if(op.equals("=="))
        {
            if(nlo instanceof List)
            {
                String l1 = toString();
                String l2 = ((List)nlo).toString();
                return new Bool(l1.equals(l2));
            }

            Interp.warn(warn);
            return new Bool(false);
        }

        if(op.equals("!="))
        {
            if(nlo instanceof List)
            {
                String l1 = toString();
                String l2 = ((List)nlo).toString();
                return new Bool(!l1.equals(l2));
            }

            Interp.warn(warn);
            return new Bool(true);
        }

        String err = "Cannot apply '" + op + "' in '" + getType() +
                     " " + op + " " + nlo.getType() + "'.";
        Interp.error(err);
        return null;
    }
}
