package NLObject;

import Interp.Interp;
import java.util.LinkedList;

public class Str implements NLObject
{
    String s;

    public Str(String s)
    {
        this.s = s;
    }

    public String getType()
    {
        return "string";
    }

    public String toString()
    {
        return s;
    }

    public NLObject op(String op, NLObject nlo)
    {
        if(op.equals("+") && nlo instanceof Str)
            return new Str(s + ((Str)nlo).s);

        if(op.equals("<") && nlo instanceof Str)
            return new Bool(s.compareTo(((Str)nlo).s) < 0);

        if(op.equals("<=") && nlo instanceof Str)
            return new Bool(s.compareTo(((Str)nlo).s) <= 0);

        if(op.equals(">") && nlo instanceof Str)
            return new Bool(s.compareTo(((Str)nlo).s) > 0);

        if(op.equals(">=") && nlo instanceof Str)
            return new Bool(s.compareTo(((Str)nlo).s) >= 0);

        if(op.equals("in") && nlo instanceof List)
        {
            String target = toString();
            List hay = (List)nlo;

            for(int i=0; i<hay.list.size(); i++)
            {
                String cand = hay.list.get(i).toString();
                if(target.equals(cand))
                    return new Bool(true);
            }

            return new Bool(false);
        }

        if(op.equals("$") && nlo instanceof List)
        {
            LinkedList l = new LinkedList();
            l.addAll( ((List)nlo).list );
            l.addFirst(nlo);
            return new List(l);
        }

        String warn = "Comparing "+ getType() +" and "+ nlo.getType() +".";

        if(op.equals("=="))
        {
            if(nlo instanceof Str)
            {
                String s2 = ((Str)nlo).s;
                return new Bool(s.equals(s2));
            }

            Interp.warn(warn);
            return new Bool(false);
        }

        if(op.equals("!="))
        {
            if(nlo instanceof Str)
            {
                String s2 = ((Str)nlo).s;
                return new Bool(!s.equals(s2));
            }

            Interp.warn(warn);
            return new Bool(true);
        }

        String err = "Cannot apply '" + op + "' in '" + getType() +
                     " " + op + " " + nlo.getType() + "'.";
        Interp.error(err);
        return null;
    }
}
